## Tables and demo records for Achievo

CREATE TABLE accessright (
   userid varchar(15) NOT NULL,
   module varchar(25) NOT NULL,
   PRIMARY KEY (userid, module)
);

INSERT INTO accessright VALUES( 'programmer1', 'houradmin');
INSERT INTO accessright VALUES( 'projectleader1', 'houradmin');
INSERT INTO accessright VALUES( 'projectleader1', 'projectadmin');
INSERT INTO accessright VALUES( 'projectleader1', 'projectstats');
INSERT INTO accessright VALUES( 'receptionist1', 'houradmin');
INSERT INTO accessright VALUES( 'salesguy1', 'projectstats');
INSERT INTO accessright VALUES( 'salesguy1', 'houradmin');
INSERT INTO accessright VALUES( 'manager', 'houradmin');
INSERT INTO accessright VALUES( 'manager', 'projectadmin');
INSERT INTO accessright VALUES( 'manager', 'projectstats');
INSERT INTO accessright VALUES( 'manager', 'activitystats');
INSERT INTO accessright VALUES( 'manager', 'billing');
INSERT INTO accessright VALUES( 'manager', 'employeeadmin');
INSERT INTO accessright VALUES( 'manager', 'employeestats');
INSERT INTO accessright VALUES( 'administrator', 'projectstats');
INSERT INTO accessright VALUES( 'administrator', 'hoursurvey');
INSERT INTO accessright VALUES( 'salesguy1', 'billing');
INSERT INTO accessright VALUES( 'salesguy1', 'userpreferences');
INSERT INTO accessright VALUES( 'administrator', 'houradmin');

CREATE TABLE activity (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   description varchar(50) NOT NULL,
   remarkrequired tinyint(4) DEFAULT '0' NOT NULL,
   PRIMARY KEY (id),
   KEY activityid (id),
   UNIQUE activityid_2 (id)
);

INSERT INTO activity VALUES( '1', 'Design', '', '0');
INSERT INTO activity VALUES( '2', 'Implementation', '', '0');
INSERT INTO activity VALUES( '3', 'Test', '', '0');
INSERT INTO activity VALUES( '4', 'Other', 'Specify!', '1');
INSERT INTO activity VALUES( '5', 'Meeting', '', '0');
INSERT INTO activity VALUES( '6', 'Travel', 'Specify!', '1');
INSERT INTO activity VALUES( '7', 'Diner', 'Businesslunches etc...', '1');
INSERT INTO activity VALUES( '8', 'Briefing', '', '0');
INSERT INTO activity VALUES( '9', 'Surveillance', '', '0');
INSERT INTO activity VALUES( '10', 'Taking Calls', '', '0');

CREATE TABLE employee (
   name varchar(40) NOT NULL,
   userid varchar(15) NOT NULL,
   ip varchar(15) NOT NULL,
   email varchar(100) NOT NULL,
   password varchar(16) NOT NULL,
   status enum('active','nonactive') DEFAULT 'active' NOT NULL,
   prefs_bgcolor varchar(6) NOT NULL,
   prefs_fontcolor varchar(6) NOT NULL,
   prefs_tableheadercolor varchar(6) NOT NULL,
   prefs_fontsize varchar(6) NOT NULL,
   prefs_titlefontcolor varchar(6) NOT NULL,
   PRIMARY KEY (userid),
   KEY userid (userid)
);

INSERT INTO employee VALUES( 'Administrator', 'administrator', '10.0.0.1', 'admin@ibuildings.net', '6d98684b668859ca', 'active', '', '', '', '', '');
INSERT INTO employee VALUES( 'J. Random Hacker', 'programmer1', '10.0.0.2', 'a@b.c', '', 'active', '', '', '', '', '');
INSERT INTO employee VALUES( 'P. Leader', 'projectleader1', '', '1@2.3', '', 'active', '', '', '', '', '');
INSERT INTO employee VALUES( 'Rachel Green', 'receptionist1', '', 'e@r.t', '', 'active', '', '', '', '', '');
INSERT INTO employee VALUES( 'Chandler Bing', 'salesguy1', '', 'z@x.n', '', 'active', '789abc', '000000', '555555', '', '');
INSERT INTO employee VALUES( 'General M. Anager', 'manager', '10.0.0.33', 'bigboss@ibuildings.net', '', 'active', '', '', '', '', '');

CREATE TABLE hours (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   entrydate date DEFAULT '0000-00-00' NOT NULL,
   date date DEFAULT '0000-00-00' NOT NULL,
   projectid int(10) unsigned DEFAULT '0' NOT NULL,
   activityid int(10) unsigned DEFAULT '0' NOT NULL,
   remark varchar(50),
   hours int(10) unsigned DEFAULT '0' NOT NULL,
   minutes tinyint(4) DEFAULT '0' NOT NULL,
   userid varchar(15) NOT NULL,
   PRIMARY KEY (id),
   KEY id (id),
   UNIQUE id_2 (id)
);

INSERT INTO hours VALUES( '1', '2000-03-16', '2000-03-16', '1', '2', '', '3', '0', 'programmer1');
INSERT INTO hours VALUES( '2', '2000-03-16', '2000-03-16', '1', '3', '', '0', '15', 'programmer1');
INSERT INTO hours VALUES( '3', '2000-03-16', '2000-03-16', '2', '10', 'Talked to my mother on the phone all day', '8', '0', 'receptionist1');
INSERT INTO hours VALUES( '4', '2000-03-16', '2000-03-16', '4', '5', 'Diner with potential customer', '2', '0', 'salesguy1');
INSERT INTO hours VALUES( '5', '2000-03-17', '2000-03-16', '4', '6', 'Flight to antarctica to meet customers', '6', '0', 'salesguy1');
INSERT INTO hours VALUES( '6', '2000-03-17', '2000-03-17', '1', '2', '', '1', '0', 'programmer1');
INSERT INTO hours VALUES( '7', '2000-03-30', '2000-03-30', '3', '9', '', '1', '0', 'administrator');
INSERT INTO hours VALUES( '8', '2000-03-30', '2000-03-29', '3', '10', '', '10', '0', 'administrator');
INSERT INTO hours VALUES( '9', '2000-03-31', '2000-03-31', '4', '5', '', '2', '0', 'salesguy1');
INSERT INTO hours VALUES( '10', '2000-04-03', '2000-04-03', '1', '2', 'fixed a bug', '3', '0', 'administrator');
INSERT INTO hours VALUES( '11', '2000-04-03', '2000-04-03', '4', '8', '', '2', '0', 'administrator');

CREATE TABLE project (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   coordinator varchar(15) NOT NULL,
   status enum('active','nonactive','archived') DEFAULT 'active' NOT NULL,
   description text NOT NULL,
   PRIMARY KEY (id),
   KEY project (id),
   UNIQUE project_2 (id)
);

INSERT INTO project VALUES( '1', 'myApp', 'projectleader1', 'active', 'Creating an App for other people');
INSERT INTO project VALUES( '2', 'First Floor Reception', 'manager', 'active', '');
INSERT INTO project VALUES( '3', 'Second Floor Reception', 'manager', 'active', 'Receptionists of the first floor should register their time on this  project');
INSERT INTO project VALUES( '4', 'The big Deal', 'manager', 'active', '');

CREATE TABLE projectactivity (
   projectid int(10) unsigned DEFAULT '0' NOT NULL,
   activityid int(10) unsigned DEFAULT '0' NOT NULL,
   billable tinyint(4) DEFAULT '0' NOT NULL,
   PRIMARY KEY (projectid, activityid)
);

INSERT INTO projectactivity VALUES( '1', '3', '1');
INSERT INTO projectactivity VALUES( '1', '2', '1');
INSERT INTO projectactivity VALUES( '1', '1', '1');
INSERT INTO projectactivity VALUES( '1', '4', '0');
INSERT INTO projectactivity VALUES( '2', '10', '0');
INSERT INTO projectactivity VALUES( '2', '9', '0');
INSERT INTO projectactivity VALUES( '2', '4', '0');
INSERT INTO projectactivity VALUES( '3', '10', '0');
INSERT INTO projectactivity VALUES( '3', '9', '0');
INSERT INTO projectactivity VALUES( '3', '4', '0');
INSERT INTO projectactivity VALUES( '4', '6', '1');
INSERT INTO projectactivity VALUES( '4', '5', '0');
INSERT INTO projectactivity VALUES( '4', '7', '1');
INSERT INTO projectactivity VALUES( '4', '4', '0');
INSERT INTO projectactivity VALUES( '4', '8', '0');

CREATE TABLE template (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   PRIMARY KEY (id),
   UNIQUE id (id)
);

INSERT INTO template VALUES( '1', 'Software Development Project');
INSERT INTO template VALUES( '2', 'Sales & Marketing Project');
INSERT INTO template VALUES( '3', 'Receptionist Project');

CREATE TABLE templateactivity (
   templateid int(10) unsigned DEFAULT '0' NOT NULL,
   activityid int(10) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (templateid, activityid)
);

INSERT INTO templateactivity VALUES( '1', '1');
INSERT INTO templateactivity VALUES( '1', '2');
INSERT INTO templateactivity VALUES( '1', '3');
INSERT INTO templateactivity VALUES( '1', '4');
INSERT INTO templateactivity VALUES( '2', '4');
INSERT INTO templateactivity VALUES( '2', '5');
INSERT INTO templateactivity VALUES( '2', '6');
INSERT INTO templateactivity VALUES( '2', '7');
INSERT INTO templateactivity VALUES( '2', '8');
INSERT INTO templateactivity VALUES( '3', '4');
INSERT INTO templateactivity VALUES( '3', '9');
INSERT INTO templateactivity VALUES( '3', '10');
