## Tables and demo records for Achievo

CREATE TABLE accessright (
   userid varchar(15) NOT NULL,
   module varchar(25) NOT NULL,
   PRIMARY KEY (userid, module)
);

CREATE TABLE activity (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   description varchar(50) NOT NULL,
   remarkrequired tinyint(4) DEFAULT '0' NOT NULL,
   PRIMARY KEY (id),
   KEY activityid (id),
   UNIQUE activityid_2 (id)
);

CREATE TABLE employee (
   name varchar(40) NOT NULL,
   userid varchar(15) NOT NULL,
   ip varchar(15) NOT NULL,
   email varchar(100) NOT NULL,
   password varchar(16) NOT NULL,
   status enum('active','nonactive') DEFAULT 'active' NOT NULL,
   prefs_bgcolor varchar(6) NOT NULL,
   prefs_fontcolor varchar(6) NOT NULL,
   prefs_tableheadercolor varchar(6) NOT NULL,
   prefs_fontsize varchar(6) NOT NULL,
   prefs_titlefontcolor varchar(6) NOT NULL,
   PRIMARY KEY (userid),
   KEY userid (userid)
);

INSERT INTO employee VALUES( 'Administrator', 'administrator', '', '', '', 'active', '', '', '', '', '');

CREATE TABLE hours (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   entrydate date DEFAULT '0000-00-00' NOT NULL,
   date date DEFAULT '0000-00-00' NOT NULL,
   projectid int(10) unsigned DEFAULT '0' NOT NULL,
   activityid int(10) unsigned DEFAULT '0' NOT NULL,
   remark varchar(50),
   hours int(10) unsigned DEFAULT '0' NOT NULL,
   minutes tinyint(4) DEFAULT '0' NOT NULL,
   userid varchar(15) NOT NULL,
   PRIMARY KEY (id),
   KEY id (id),
   UNIQUE id_2 (id)
);

CREATE TABLE project (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   coordinator varchar(15) NOT NULL,
   status enum('active','nonactive','archived') DEFAULT 'active' NOT NULL,
   description text NOT NULL,
   PRIMARY KEY (id),
   KEY project (id),
   UNIQUE project_2 (id)
);

CREATE TABLE projectactivity (
   projectid int(10) unsigned DEFAULT '0' NOT NULL,
   activityid int(10) unsigned DEFAULT '0' NOT NULL,
   billable tinyint(4) DEFAULT '0' NOT NULL,
   PRIMARY KEY (projectid, activityid)
);

CREATE TABLE template (
   id int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   PRIMARY KEY (id),
   UNIQUE id (id)
);

CREATE TABLE templateactivity (
   templateid int(10) unsigned DEFAULT '0' NOT NULL,
   activityid int(10) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (templateid, activityid)
);

