<?

  require "config.inc.php3";

  if ($config_usephplib==false)
  {
    require "db_mysql.inc";
  }
  require "tools.inc";
  require $config_languagefile;

  if ((!isset($novalidate)) && (!isset($usercookie) || $usercookie=="nobody"))
  {
    header("Location: index.php3");  /* Redirect browser */
    exit;  /* Make sure that code below does not get executed when we redirect. */
  }

  class achievodb  extends DB_Sql
  {

    // - host & database info
    var $Host;
    var $Database;
    var $User;
    var $Password;

    // - tabelnamen
    var $tbl_hours     	       = "hours";			
   
    var $tbl_activity  	       = "activity";
    var $tbl_project            = "project";
    var $tbl_employee           = "employee";
    var $tbl_projectactivity    = "projectactivity";
    var $tbl_template           = "template";
    var $tbl_templateactivity   = "templateactivity";
    var $tbl_accessright        = "accessright";

    // Constructor
    function achievodb()
    {
      global $config_databasehost,$config_databasename,$config_databaseuser,$config_databasepassword;
      // Initialise some variables:
      $this->Host          = $config_databasehost;
      $this->Database      = $config_databasename;
      $this->User          = $config_databaseuser;
      $this->Password      = $config_databasepassword;

    }

    // - TableName(tabelvar)
    // - retourneren van de echte tabelnaam
    function TableName($var)
    {
      return $this->$var;
    }

    function CheckPassword($userid, $password)
    {
      $a = $this->TableName("tbl_employee");
      $query="select name,password from $a where userid='$userid' and password=PASSWORD('$password')";
      $this->query($query);
      $this->next_record();
      return ($this->num_rows()!=0);
    }

    function ChangePassword($userid, $newpassword)
    {
      $a = $this->TableName("tbl_employee");
      $query="update $a set password = PASSWORD('$newpassword') where userid='$userid'";
      $this->query($query);
    }



    function SelectUsers()
    {
      $b     = $this->TableName("tbl_employee");
      $query = "SELECT userid, name, email,ip FROM $b";
      $this->query($query);
      return $this->affected_rows();
    }


    function SelectProject($projectid)
    {
      $b     = $this->TableName("tbl_project");
      $query = "SELECT id,name,$b.status,description,coordinator FROM $b WHERE id=$projectid";
      $this->query($query);
      return $this->affected_rows();
    }

    function SelectAllProjects($status="")
    {
      $a     = $this->TableName("tbl_employee");
      $b     = $this->TableName("tbl_project");
      $query = "SELECT id, $b.name, $b.status, coordinator, $a.name as coordinatorname, email ";
      $query.= "FROM $a,$b ";
      $query.= "WHERE $a.userid=coordinator ";
      if ($status!="")
      {
        $query.= "AND $b.status='$status' ";
      }
      $query.= "ORDER BY $b.name";
       //echo $query;
      $this->query($query);
      return $this->affected_rows();
    }

    function GetRecentProjects($userid)
    {
      global $config_numberofrecentprojects;
      $a     = $this->TableName("tbl_hours");
      $b     = $this->TableName("tbl_project");
      $query = "SELECT $b.id, $b.name FROM $b,$a ";
      $query.= "WHERE $b.id=$a.projectid AND userid='$userid' AND $b.status='active' ";
      $query.= "ORDER BY $a.entrydate DESC LIMIT 100";
      //echo $query;
      $arr = $this->getrows($query);
      $j=0;
      $alreadyhad = Array();
      $newarr = Array();
      if (!isset($config_numberofrecentprojects)||$config_numberofrecentprojects=="")
      { 
        $config_numberofrecentprojects = 5;
      }
      for ($i=0;$i<count($arr)&&$j<$config_numberofrecentprojects;$i++)
      {
        if (!in_array($arr[$i]['id'],$alreadyhad))
        {
          $alreadyhad[$j]=$arr[$i]['id'];
          $newarr[$j]['id'] = $arr[$i]['id'];
          $newarr[$j]['name'] = $arr[$i]['name'];
          $j++;
        }
      }
      return $newarr;
    }

    // Get activities that belong to a given project. If 0 is passed, all activities are returned.
    function GetActivities($projectid=0)
    {
      $tbl_activity = $this->TableName("tbl_activity");
      if ($projectid!=0)
      {
        $tbl_projectactivity = $this->TableName("tbl_projectactivity");
        $query = "SELECT id, name, description, remarkrequired, billable FROM $tbl_activity, $tbl_projectactivity ";
        $query.= "WHERE $tbl_projectactivity.projectid = $projectid AND $tbl_activity.id = $tbl_projectactivity.activityid ";
        $query.= "ORDER BY name";
      }
      else
      {
        $query = "SELECT id, name, description, remarkrequired FROM $tbl_activity ORDER BY name";
      }
      return $this->getrows($query);
    }

    function GetProject($projectid)
    {
      $a     = $this->TableName("tbl_employee");
      $b     = $this->TableName("tbl_project");
      $query = "SELECT id, $b.name as projectname, description, $b.status, coordinator, $a.name as coordinatorname, email ";
      $query.= "FROM $a,$b ";
      $query.= "WHERE $b.id=$projectid AND $a.userid=coordinator ";
      $arr = $this->getrows($query);
      $project = $arr[0];
      return $project;
    }

    function GetActivity($activityid)
    {
      $a     = $this->TableName("tbl_activity");
      $query = "SELECT id, name, description, remarkrequired ";
      $query.= "FROM $a ";
      $query.= "WHERE id=$activityid ";
      $arr = $this->getrows($query);
      $activity = $arr[0];
      return $activity;
    }

    function GetEmployee($userid)
    {
      $a     = $this->TableName("tbl_employee");
      $query = "SELECT * ";
      $query.= "FROM $a ";
      $query.= "WHERE userid='$userid' ";
      $arr = $this->getrows($query);
      if (count($arr)>0)
        $employee = $arr[0];
      else
        $employee = array();
      return $employee;
    }

    function DeleteEmployee($userid)
    {
      $this->Halt_On_Error = 'yes';
      $a = $this->TableName("tbl_employee");

      $query  = "DELETE FROM $a WHERE userid='$userid'";
      $this->query($query);
    }


    function AddEmployee($userid)
    {
      $a = $this->TableName("tbl_employee");

      $query  = "INSERT INTO $a (userid) VALUES ('$userid')";
      $this->query($query);
    }

    function UpdateEmployee($id, $name, $email, $ip, $allowance)
    {
      $a = $this->TableName("tbl_employee");
      $b = $this->TableName("tbl_accessright");

      // Delete all rights from employee and then reinsert the new ones (hmm...
      // really bad way to do things actually :-)
      $query = "DELETE from $b WHERE userid='$id'";
      $this->query($query);

      while (list($key, $value) = each($allowance))
      {
        if ($value=="Y")
        {
          $query = "INSERT INTO $b (userid, module) VALUES ('$id','$key')";
          $this->query($query);
        }
      }

      $query  = "UPDATE $a SET name='$name', email='$email', ip='$ip' WHERE userid='$id'";
      $this->query($query);
    }

    function UpdateUserPreferences($id, $bgcolor, $fontcolor, $titlefontcolor, $tableheadercolor)
    {
      $a = $this->TableName("tbl_employee");

      $query  = "UPDATE $a SET prefs_bgcolor='$bgcolor', prefs_fontcolor='$fontcolor', prefs_titlefontcolor='$titlefontcolor', prefs_tableheadercolor='$tableheadercolor' WHERE userid='$id'";
      $this->query($query);
    }

    function GetTemplateActivities($templateid)
    {
      $a = $this->TableName("tbl_templateactivity");
      $query = "SELECT activityid FROM $a WHERE templateid=$templateid";
      return $this->getrows($query);
    }

    function GetTemplates()
    {
      $a = $this->TableName("tbl_template");
      $query = "SELECT id, name FROM $a ORDER BY name";
      return $this->getrows($query);
    }

    function GetTemplate($templateid)
    {
      $a = $this->TableName("tbl_template");
      $query = "SELECT id, name FROM $a WHERE id=$templateid";
      return $this->getrows($query);
    }


    function RemarkRequired($activityid)
    {
      $a = $this->TableName("tbl_activity");
      $query = "SELECT remarkrequired FROM $a WHERE id = $activityid";
      $this->query($query);
      $this->next_record();
      return $this->f('remarkrequired');

    }

    function SelectHoursByDay($userid, $timestamp)
    {
      global $config_activities;
      $a     = $this->TableName("tbl_project");
      $b     = $this->TableName("tbl_hours");
      $c     = $this->TableName("tbl_activity");
      $today = strftime("%Y-%m-%d",$timestamp);


      if ($config_activities)
      {
        $query = "SELECT $b.id as hoursid, projectid, $a.name as project, date, $c.name as activity, activityid, remark, hours, minutes FROM $a,$b,$c ";
        $query.= "WHERE date = '$today' AND $a.id = $b.projectid AND $c.id = $b.activityid AND userid='$userid' ";
      }
      else
      {
        $query = "SELECT $b.id as hoursid, projectid, $a.name as project, date, hours, minutes FROM $a,$b ";
        $query.= "WHERE date = '$today' AND $a.id = $b.projectid AND userid='$userid' ";
      }
     $query.= "ORDER BY $b.id";
      $this->query($query);
      return $this->affected_rows();
    }

    function GetProjectName($projectid)
    {
      $a     = $this->TableName("tbl_project");
      $query = "SELECT name FROM $a WHERE id=$projectid";
      $this->query($query);
      $this->next_record();
      return $this->f('name');
    }

    function GetHours($hoursid)
    {
      global $config_activities;
      $a     = $this->TableName("tbl_project");
      $b     = $this->TableName("tbl_hours");
      $c     = $this->TableName("tbl_activity");
      if ($config_activities)
      {
        $query = "SELECT $b.id as hoursid, projectid, $a.name as project, date, $c.name as activity, activityid, remark, hours, minutes FROM $a,$b,$c ";
        $query.= "WHERE hours.id=$hoursid AND $a.id = $b.projectid AND $c.id = $b.activityid";
      }
      else
      {
        $query = "SELECT $b.id as hoursid, projectid, $a.name as project, date, hours, minutes FROM $a,$b ";
        $query.= "WHERE hours.id=$hoursid AND $a.id = $b.projectid";
      }
      return $this->getrows($query);
    }

    function SelectHoursInRange($projectid, $firstdate, $lastdate, $userid="", $activityid=0, $orderby="")
    {
      global $config_activities;
      $a = $this->TableName("tbl_project");
      $b = $this->TableName("tbl_hours");
      $c = $this->TableName("tbl_employee");
      $d = $this->TableName("tbl_activity");

      $query = "SELECT $b.id as hoursid, $b.date, $b.projectid as projectid, $b.hours, $b.minutes, $b.remark, ";
      $query.= "$a.name as project, $c.name as employeename, $c.email as email, $c.userid as userid, ";
      $query.= "(($b.hours*60)+$b.minutes) as time ";
      if ($config_activities)
      {
        $query.= ", $d.name as activityname, $d.id as activityid ";
      }
      $query.= "FROM $a,$b,$c ";
      if ($config_activities)
      {
        $query.=",$d ";
      }
      $query.= "WHERE date >= '$firstdate' AND date<='$lastdate' ";
      $query.= "AND $c.userid = $b.userid ";
      $query.= "AND $a.id = $b.projectid ";
      if ($config_activities)
      {
        $query.= "AND $b.activityid = $d.id ";
      }
      if ($projectid!=0)
      {
        $query.= "AND $b.projectid=$projectid ";
      }
      if ($userid!=""&&$userid!="all")
      {
        $query.= "AND $b.userid='$userid' ";
      }
      if ($config_activities&&($activityid!=0))
      {
        $query.= "AND $b.activityid=$activityid ";
      }
      if ($orderby=="")
      {
        $query.= " ORDER BY $b.id";
      }
      else
      {
        $query.=" ORDER BY $orderby";
      }
      $this->query($query);
      return $this->affected_rows();
    }

    function SelectHoursWithBillability($projectid, $firstdate, $lastdate)
    {
      global $config_activities;
      $a = $this->TableName("tbl_project");
      $b = $this->TableName("tbl_hours");
      $c = $this->TableName("tbl_employee");
      $d = $this->TableName("tbl_activity");
      $e = $this->TableName("tbl_projectactivity");

      $query = "SELECT $b.id as hoursid, $b.date, $b.hours, $b.minutes, $b.remark, ";
      $query.= "$a.name as project, $c.name as employeename, $e.billable";
      if ($config_activities)
      {
        $query.= ", $d.name as activityname, $d.id as activityid ";
      }
      $query.= "FROM $a,$b LEFT JOIN $e USING(projectid,activityid),$c ";
      if ($config_activities)
      {
        $query.=",$d ";
      }
      $query.= "WHERE date >= '$firstdate' AND date<='$lastdate' ";
      $query.= "AND $c.userid = $b.userid ";
      $query.= "AND $a.id = $b.projectid ";
      $query.= "AND $b.projectid = $projectid ";
      if ($config_activities)
      {
        $query.= "AND $b.activityid = $d.id ";
      }
      $query.=" ORDER BY date";

      $this->query($query);
      return $this->affected_rows();
    }

    function SelectBillHours($hoursidarray)
    {
      global $config_activities;
      $b = $this->TableName("tbl_hours");
      $d = $this->TableName("tbl_activity");

      $query = "SELECT $b.id as hoursid, $b.hours, $b.minutes, $b.date";
      if ($config_activities)
      {
        $query.= ", $d.name as activityname, $d.id as activityid ";
      }
      $query.= "FROM $b ";
      if ($config_activities)
      {
        $query.=",$d ";
      }
      if (count($hoursidarray)>0)
      {
        while (list($key, $value) = each($hoursidarray))
        {
          if ($value!="")
          {
            $hoursidarraystr .= $key.",";
          }
        }
      }
      // now there's one comma too much at the end, which we will strip:
      $hoursidarraystr = substr($hoursidarraystr,0,strlen($hoursidarraystr)-1);

      $query.= "WHERE hours.id IN ($hoursidarraystr) ";
      if ($config_activities)
      {
        $query.= "AND $b.activityid = $d.id ";
      }
      $query.=" ORDER BY date";

      $this->query($query);
      return $this->affected_rows();
    }



    function AddHours($date, $projectid, $userid, $activityid, $remark, $hours, $minutes)
    {
      global $config_activities;
      $b = $this->TableName("tbl_hours");
      $d = strftime("%Y-%m-%d");

      if ($config_activities)
      {
        $remark = addslashes(strip_tags($remark));
        $query  = "INSERT INTO $b (entrydate, date, projectid, activityid, remark, hours, minutes, userid)";
        $query .= "VALUES ('$d','$date', $projectid, $activityid, '$remark', $hours, $minutes, '$userid')";
      }
      else
      {
        $query  = "INSERT INTO $b (entrydate, date, projectid, hours, minutes, userid)";
        $query .= "VALUES ('$d','$date', $projectid, $hours, $minutes, '$userid')";
      }
      $this->query($query);
    }

    function UpdateHours($hoursid, $date, $projectid, $userid, $activityid, $remark, $hours, $minutes)
    {
      global $config_activities;
      $b = $this->TableName("tbl_hours");
      $d = strftime("%Y-%m-%d");
      if ($config_activities)
      {
        $remark = addslashes(strip_tags($remark));
        $query  = "UPDATE $b SET entrydate='$d', projectid=$projectid, activityid=$activityid, remark='$remark', hours=$hours, minutes=$minutes ";
        $query .= "WHERE id=$hoursid";
      }
      else
      {
        $query  = "UPDATE $b SET entrydate='$d', projectid=$projectid, hours=$hours, minutes=$minutes ";
        $query .= "WHERE id=$hoursid";
      }
      //echo $query;
      $this->query($query);
    }

    function AddProject($id, $name, $templateid, $userid)
    {
       global $config_activities;
      $a = $this->TableName("tbl_project");
      $b = $this->TableName("tbl_templateactivity");
      $c = $this->TableName("tbl_projectactivity");

      $query  = "INSERT INTO $a (id, name, coordinator) VALUES ($id, '$name','$userid')";
      $this->query($query);
      $returnvalue = $this->InsertId();

      if ($config_activities && ($templateid!=0))
      {
        $templateactivityarray = $this->GetTemplateActivities($templateid);
        for ($i=0;$i<count($templateactivityarray);$i++)
        {
          $activityid = $templateactivityarray[$i]['activityid'];
          $query="INSERT INTO $c (projectid, activityid, billable) VALUES ($returnvalue, $activityid, 1)";
          $this->query($query);
        }
      }

      return $returnvalue;
    }

    function AddTemplate($name)
    {
      $a = $this->TableName("tbl_template");

      $query  = "INSERT INTO $a (name) VALUES ('$name')";
      $this->query($query);
      $returnvalue = $this->InsertId();
      return $returnvalue;
    }


    function AddActivity($name, $description, $remarkrequired)
    {
      $a = $this->TableName("tbl_activity");

      $query  = "INSERT INTO $a (name, description, remarkrequired) VALUES ('$name','$description',$remarkrequired)";
//      echo $query;
      $this->query($query);
    }


    function UpdateProject($projectid, $name, $status, $description, $coordinator, $activityarray, $billablearray)
    {
      global $config_activities;

      $a = $this->TableName("tbl_project");
      $b = $this->TableName("tbl_projectactivity");
      $query  = "UPDATE $a SET name='$name', $a.status='$status', description='$description', coordinator='$coordinator' WHERE id=$projectid";
      $this->query($query);

      if ($config_activities)
      {
        // Update the activities.. The lazy way: delete all records and then add the ones that
        // are checked.

        $query = "DELETE from $b WHERE projectid=$projectid";
        $this->query($query);

        if (count($activityarray)!=0)
        {
          while (list($actid,$value) = each($activityarray))
          {
            if ($value!="")
            {
              if ($billablearray[$actid]!="")
              {
                $billable=1;
              }
              else
              {
                $billable=0;
              }
              $query = "INSERT INTO $b (projectid, activityid, billable) VALUES ($projectid, $actid, $billable)";
              $this->query($query);
            }
          }
        }
      }

    }

    function DeleteProject($id)
    {
      $this->Halt_On_Error = 'yes';
    
      $a = $this->TableName("tbl_project");
      $b = $this->TableName("tbl_projectactivity");

      /* Can't bill any activities without project. */

      $query = "DELETE from $b WHERE projectid=$id";
      $this->query($query);
      /* The whole point of this function. */

      $query = "DELETE from $a WHERE id='$id'";
      $this->query($query);
    }

    function UpdateTemplate($templateid, $name, $activityarray)
    {
      $a = $this->TableName("tbl_template");
      $b = $this->TableName("tbl_templateactivity");
      $query  = "UPDATE $a SET name='$name' WHERE id=$templateid";
      $this->query($query);

      // Update the activities.. The lazy way: delete all records and then add the ones that
      // are checked.

      $query = "DELETE from $b WHERE templateid=$templateid";
      $this->query($query);

      if (count($activityarray)!=0)
      {
        while (list($actid,$value) = each($activityarray))
        {
          if ($value!="")
          {
            $query = "INSERT INTO $b (templateid, activityid) VALUES ($templateid, $actid)";
            $this->query($query);
          }
        }
      }
    }

    function UpdateActivity($activityid, $name, $description, $remarkrequired)
    {
      $a = $this->TableName("tbl_activity");
      $query  = "UPDATE $a SET name='$name', description='$description', remarkrequired=$remarkrequired WHERE id=$activityid";
      $this->query($query);
    }


    function DeleteHours($hoursid)
    {
      $b = $this->TableName("tbl_hours");

      $query  = "DELETE FROM $b WHERE id=$hoursid";
      $this->query($query);
    }

    function GetAccessList($userid)
    {
      $a = $this->TableName("tbl_accessright");
      $query = "SELECT module FROM $a WHERE userid='$userid'";

      $arr = $this->getrows($query);
      $AccessList = Array();
      for ($i=0;$i<count($arr);$i++)
      {
        $AccessList[$i]=$arr[$i]['module'];
      }

      return $AccessList;
    }

    function getrows($query)
    {
      $myrow = 0;
      $this->query($query);
      while ($this->next_record())
      {
        $aRet[$myrow] =$this->Record;
        $myrow++;
      }
      return $aRet;
    }

    function InsertId()
    {
      return mysql_insert_id($this->Link_ID);
    }

  }

  // Create the one and only database object.
  $db = new achievodb;

  // Global employee object.
  $g_employee = $db->GetEmployee($usercookie);
  $g_employee['accesslist']=$db->GetAccessList($usercookie);
  require "layout.inc";

?>
